﻿using System;
using System.Drawing;
using System.Collections;

namespace MazeTry
{
    public class Maze
    {
        private int padd;
        private Random currentCelda;
        
        struct celda 
        {
            //0: no hay pared
            //1: hay pared
            //3: bordes
            public byte L1, L2, piso;
        }

        private celda[][] celda0;

        public Maze()
        {
            padd = 10;
            currentCelda = new Random(DateTime.Now.Millisecond);
        }

        public void Generar(Graphics g, int LimiteH, int LimiteV, bool primereVez) 
        {
            Stack pila1 = new Stack(); 
            Stack pila2 = new Stack();            
            
            int totalCeldas, visitedCeldas, thisCelda1, thisCelda2;
            int masdeunaCelda, otraCelda;
            int m = 0, n = 0;
  
            for (int i = 0; i <= LimiteH; i += padd)
                n++; //Horizontal

            for (int i = 0; i <= LimiteV; i += padd)
                m++; //vertical

            int pisos = m < n ? m : n;
            pisos -= 10;

            totalCeldas = 0;
            
            if (primereVez)
            {
                for (int i = 0; i < pisos; i++)
                    totalCeldas += (2 * i + 1);

                celda0 = new celda[pisos][];

                for (int i = 0; i < pisos; i++)
                    for (int j = 0; j < i*2+1; j++)
                        celda0[i]= new celda [j+1];
                
                for (int i = 0; i < pisos; i++)
                    for (int j = 0; j < i*2+1; j++)
                    {
                        celda0[i][j].L1 = 1;
                        celda0[i][j].L2 = 1;
                        celda0[i][j].piso = 1;
                                              
                        if (j == 0)
                            celda0[i][j].L1 = 3;

                        if (j == i * 2)
                            celda0[i][j].L2 = 3;

                        if (i == pisos-1)
                            celda0[i][j].piso = 3;
                    }

                /*
                 * create a CellStack (LIFO) to hold a list of cell locations  
                set TotalCells = number of cells in grid  
                choose a cell at random and call it CurrentCell  
                set VisitedCells = 1  
   
                while VisitedCells < TotalCells  
                find all neighbors of CurrentCell with all walls intact   
                if one or more found  
                choose one at random  
                knock down the wall between it and CurrentCell  
                push CurrentCell location on the CellStack  
                make the new cell CurrentCell  
                add 1 to VisitedCells off the CellStack   
                else  
                pop the most recent cell entry
                make it CurrentCell 
                endIf 
                endWhile  
                 */
                
                visitedCeldas = 1;
                thisCelda1 = (int)currentCelda.Next(0, pisos); //Random no incluye el maximo valor
                thisCelda2 = (int)currentCelda.Next(0, 2 * thisCelda1 + 1);

                while (visitedCeldas < totalCeldas)
                {
                    masdeunaCelda = 0;

                    if (celda0[thisCelda1][thisCelda2].L1 == 1)
                        if (celda0[thisCelda1][thisCelda2 - 1].L1 != 0 &&
                            celda0[thisCelda1][thisCelda2 - 1].L2 != 0 &&
                            celda0[thisCelda1][thisCelda2 - 1].piso != 0)
                            masdeunaCelda++;

                    if (celda0[thisCelda1][thisCelda2].L2 == 1)
                        if (celda0[thisCelda1][thisCelda2 + 1].L1 != 0 &&
                            celda0[thisCelda1][thisCelda2 + 1].L2 != 0 &&
                            celda0[thisCelda1][thisCelda2 + 1].piso != 0)
                            masdeunaCelda++;

                    int uno = thisCelda2 % 2 == 0 ? 1 : -1;

                    //es un laberinto triangular!!!
                    if (celda0[thisCelda1][thisCelda2].piso == 1)
                        if (celda0[thisCelda1 + uno][thisCelda2 + uno].L1 != 0 &&
                            celda0[thisCelda1 + uno][thisCelda2 + uno].L2 != 0 &&
                            celda0[thisCelda1 + uno][thisCelda2 + uno].piso != 0)
                            masdeunaCelda++;

                    if (masdeunaCelda > 0) // hay al menos una celda vecina con todas sus paredes
                    {
                        otraCelda = cogerCelda(ref celda0, thisCelda1, thisCelda2);
                        pila1.Push(thisCelda1);
                        pila2.Push(thisCelda2);

                        switch (otraCelda)
                        {
                            case 1:
                                thisCelda1++;
                                thisCelda2++;
                                break;

                            case 2:
                                thisCelda1--;
                                thisCelda2--;
                                break;

                            case 3:
                                thisCelda2--;
                                break;

                            case 4:
                                thisCelda2++;
                                break;
                        }

                        visitedCeldas++;
                    }

                    else
                    {
                        thisCelda1 = (int)pila1.Pop();
                        thisCelda2 = (int)pila2.Pop();
                    }
                
                } // se terminó el while */
            }  // se terminò el if(primeraVez)
            
            DibujarLab(g, pisos, LimiteV, LimiteH);  
        }

        private int cogerCelda(ref celda[][] celda0, int thisCelda1, int thisCelda2) 
        {
            int escoger;
            bool valor = true;
            int c = 0;

            while (valor)
            {
                escoger = currentCelda.Next(1,4);

                switch (escoger)
                {
                    case 1:
                        if (celda0[thisCelda1][thisCelda2].piso == 1)
                        {
                            int uno = thisCelda2 % 2 == 0 ? 1 : -1;
                            if (celda0[thisCelda1 + uno][thisCelda2 + uno].L1 != 0 &&
                                celda0[thisCelda1 + uno][thisCelda2 + uno].L2 != 0 &&
                                celda0[thisCelda1 + uno][thisCelda2 + uno].piso != 0)
                            {
                                celda0[thisCelda1][thisCelda2].piso = 0;
                                celda0[thisCelda1 + uno][thisCelda2 + uno].piso = 0;
                                valor = false;
                                c = thisCelda2 % 2 == 0 ? 1 : 2;
                                //hará thisCelda1++ ò thisCelda1-- dependiendo de la orientaciòn
                            }
                        }
                        break;

                    case 2:
                        if (celda0[thisCelda1][thisCelda2].L1 == 1)
                            if (celda0[thisCelda1][thisCelda2 - 1].L1 != 0 &&
                                celda0[thisCelda1][thisCelda2 - 1].L2 != 0 &&
                                celda0[thisCelda1][thisCelda2 - 1].piso != 0)
                            {
                                celda0[thisCelda1][thisCelda2].L1 = 0;
                                celda0[thisCelda1][thisCelda2 - 1].L2 = 0;
                                valor = false;
                                c = 3;
                                //hará thisCelda2--;
                            }                        
                        break;

                    case 3:
                        if (celda0[thisCelda1][thisCelda2].L2 == 1)
                            if (celda0[thisCelda1][thisCelda2 + 1].L1 != 0 &&
                                celda0[thisCelda1][thisCelda2 + 1].L2 != 0 &&
                                celda0[thisCelda1][thisCelda2 + 1].piso != 0)
                            {
                                celda0[thisCelda1][thisCelda2].L2 = 0;
                                celda0[thisCelda1][thisCelda2 + 1].L1 = 0;
                                valor = false;
                                c = 4;
                                //hará thisCelda2++;
                            }
                        break;
                   
                }              
            }
           
            return c;
        }
        
        private void DibujarLab(Graphics g, int pisos, int LimiteV, int LimiteH) 
        {
            int m2 = 0, n2 = 0, n3 = 0;
            LimiteH /= 2;

            for (int i = 0; i <pisos; i++)
            {
                int i2 = i * padd;
                n2 = 0; n3 = 0;
                
                for (int j = LimiteH - padd * (i + 1); j <= LimiteH + padd * (i + 1); j += padd)
                {
                    if (n2 % 2 == 0)
                    {
                        if (celda0[m2][n2].L1 == 1 || celda0[m2][n2].L1 == 3)
                            g.DrawLine(Pens.Black, j + padd, i2, j, i2 + padd);

                        if (celda0[m2][n2].L2 == 1 || celda0[m2][n2].L2 == 3)
                            g.DrawLine(Pens.Black, j + padd, i2, j + 2 * padd, i2 + padd);

                        if (celda0[m2][n2].piso == 1 || celda0[m2][n2].piso == 3)
                            g.DrawLine(Pens.Black, j, i2 + padd, j + 2 * padd, i2 + padd);
                    }
                    n2++;
                    if (n2 == m2*2 + 1) break;
                }
                
                for (int j = LimiteH - padd * i; j <= LimiteH + padd * i; j += padd)
                {
                    if (n3 % 2 != 0)
                    {
                        if (celda0[m2][n3].L1 == 1 || celda0[m2][n3].L1 == 3)
                            g.DrawLine(Pens.Black, j, i2, j + padd, i2 + padd);

                        if (celda0[m2][n3].L2 == 1 || celda0[m2][n3].L2 == 3)
                            g.DrawLine(Pens.Black, j + padd, i2 + padd, j + 2 * padd, i2);

                        if (celda0[m2][n3].piso == 1 || celda0[m2][n3].piso == 3)
                            g.DrawLine(Pens.Black, j, i2, j + 2 * padd, i2);
                    }
                    n3++;
                    if (n2 == m2*2 + 1) break;
                }
                m2++;
                if (m2 == pisos) break;
            }

        }

    }
}
